##Procedure Header
# Name:
#    ::ixiangpf::emulation_rsvpte_tunnel_control
#
# Description:
#    Control Operation on the RSVP TE Tunnel
#    The following operations are done:
#    1. Start
#    2. Stop
#    3. Restart
#    4. Restart Down
#    6. Abort
#
# Synopsis:
#    ::ixiangpf::emulation_rsvpte_tunnel_control
#        -mode    CHOICES restart
#                 CHOICES start
#                 CHOICES restart_down
#                 CHOICES stop
#                 CHOICES abort
#                 CHOICES make_before_break
#                 CHOICES initiate_path_reoptimization
#        [-handle ANY]
#
# Arguments:
#    -mode
#        What is being done to the protocol.Valid choices are:
#        restart - Restart the protocol.
#        start- Start the protocol.
#        stop- Stop the protocol.
#        restart_down- Restart the down sessions.
#        abort- Abort the protocol.
#    -handle
#        RSVP TE Tunnel handle where the rsvp te tunnel control action is applied.
#
# Return Values:
#    $::SUCCESS | $::FAILURE
#    key:status  value:$::SUCCESS | $::FAILURE
#    If status is failure, detailed information provided.
#    key:log     value:If status is failure, detailed information provided.
#
# Examples:
#
# Sample Input:
#
# Sample Output:
#
# Notes:
#
# See Also:
#

proc ::ixiangpf::emulation_rsvpte_tunnel_control { args } {

	set notImplementedParams "{}"
	set mandatoryParams "{}"
	set fileParams "{}"
	set flagParams "{}"
	set procName [lindex [info level [info level]] 0]
	::ixia::logHltapiCommand $procName $args
	::ixia::utrackerLog $procName $args
	return [eval runExecuteCommand "emulation_rsvpte_tunnel_control" $notImplementedParams $mandatoryParams $fileParams $flagParams $args]
}
